
#include <linux/list.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <mntent.h>
#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>
#include <stdio.h>
#include <string.h> 

#include "gl.c"
#include "sdl.c"
#include "gui.c"

#include "frontend.c"

int main(int argc, char *argv[]) {
	sdl_init();
	gui_init();
	glinit_objects();
	frontend_init();

	if (argc == 2) {
		vcad_file_load(argv[1]);

		// Start in 3D-Mode
		vcad_image_raster_view();
		vcad_view_3d();
	}

	while (gui_running == 1) {
		gui_check();
		glMatrixMode(GL_MODELVIEW);
		glClearColor(0.0, 0.0, 0.0, 1.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		vcad_draw();
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
		gui_draw();
		usleep(100);
	}
	gui_exit();
	return 0;
}





